/* A Bison parser, made from ./rcfile_y.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	DEFAULTS	257
# define	POLL	258
# define	SKIP	259
# define	VIA	260
# define	AKA	261
# define	LOCALDOMAINS	262
# define	PROTOCOL	263
# define	AUTHENTICATE	264
# define	TIMEOUT	265
# define	KPOP	266
# define	SDPS	267
# define	ENVELOPE	268
# define	QVIRTUAL	269
# define	USERNAME	270
# define	PASSWORD	271
# define	FOLDER	272
# define	SMTPHOST	273
# define	FETCHDOMAINS	274
# define	MDA	275
# define	BSMTP	276
# define	LMTP	277
# define	SMTPADDRESS	278
# define	SMTPNAME	279
# define	SPAMRESPONSE	280
# define	PRECONNECT	281
# define	POSTCONNECT	282
# define	LIMIT	283
# define	WARNINGS	284
# define	NETSEC	285
# define	INTERFACE	286
# define	MONITOR	287
# define	PLUGIN	288
# define	PLUGOUT	289
# define	IS	290
# define	HERE	291
# define	THERE	292
# define	TO	293
# define	MAP	294
# define	WILDCARD	295
# define	BATCHLIMIT	296
# define	FETCHLIMIT	297
# define	EXPUNGE	298
# define	PROPERTIES	299
# define	SET	300
# define	LOGFILE	301
# define	DAEMON	302
# define	SYSLOG	303
# define	IDFILE	304
# define	INVISIBLE	305
# define	POSTMASTER	306
# define	BOUNCEMAIL	307
# define	SPAMBOUNCE	308
# define	SHOWDOTS	309
# define	PROTO	310
# define	AUTHTYPE	311
# define	STRING	312
# define	NUMBER	313
# define	NO	314
# define	KEEP	315
# define	FLUSH	316
# define	FETCHALL	317
# define	REWRITE	318
# define	FORCECR	319
# define	STRIPCR	320
# define	PASS8BITS	321
# define	DROPSTATUS	322
# define	DROPDELIVERED	323
# define	DNS	324
# define	SERVICE	325
# define	PORT	326
# define	UIDL	327
# define	INTERVAL	328
# define	MIMEDECODE	329
# define	IDLE	330
# define	CHECKALIAS	331
# define	SSL	332
# define	SSLKEY	333
# define	SSLCERT	334
# define	SSLPROTO	335
# define	SSLCERTCK	336
# define	SSLCERTPATH	337
# define	SSLFINGERPRINT	338
# define	PRINCIPAL	339
# define	ESMTPNAME	340
# define	ESMTPPASSWORD	341
# define	TRACEPOLLS	342

#line 1 "./rcfile_y.y"

/*
 * rcfile_y.y -- Run control file parser for fetchmail
 *
 * For license terms, see the file COPYING in this directory.
 */

#include "config.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#if defined(HAVE_SYS_WAIT_H)
#include <sys/wait.h>
#endif
#include <sys/stat.h>
#include <errno.h>
#if defined(STDC_HEADERS)
#include <stdlib.h>
#endif
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
#include <string.h>

#if NET_SECURITY
#include <net/security.h>
#endif /* NET_SECURITY */

#include "fetchmail.h"
#include "i18n.h"
  
/* parser reads these */
char *rcfile;			/* path name of rc file */
struct query cmd_opts;		/* where to put command-line info */

/* parser sets these */
struct query *querylist;	/* head of server list (globally visible) */

int yydebug;			/* in case we didn't generate with -- debug */

static struct query current;	/* current server record */
static int prc_errflag;
static struct hostdata *leadentry;
static flag trailer;

static void record_current(void);
static void user_reset(void);
static void reset_server(const char *name, int skip);

/* these should be of size PATH_MAX */
char currentwd[1024] = "", rcfiledir[1024] = "";

/* using Bison, this arranges that yydebug messages will show actual tokens */
extern char * yytext;
#define YYPRINT(fp, type, val)	fprintf(fp, " = \"%s\"", yytext)

#line 58 "./rcfile_y.y"
#ifndef YYSTYPE
typedef union {
  int proto;
  int number;
  char *sval;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		210
#define	YYFLAG		-32768
#define	YYNTBASE	89

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 342 ? yytranslate[x] : 112)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     3,     5,     8,    10,    11,    16,    21,
      26,    31,    34,    38,    41,    45,    50,    53,    57,    60,
      64,    67,    71,    74,    78,    83,    86,    89,    91,    92,
      95,    97,   100,   102,   105,   108,   111,   114,   117,   120,
     123,   126,   129,   132,   134,   137,   139,   142,   145,   148,
     151,   154,   157,   161,   164,   167,   170,   173,   176,   179,
     182,   184,   187,   190,   192,   195,   197,   199,   201,   204,
     207,   210,   214,   218,   219,   222,   224,   227,   229,   231,
     234,   236,   239,   241,   245,   247,   250,   252,   255,   257,
     260,   262,   265,   269,   272,   276,   279,   283,   286,   289,
     292,   295,   298,   301,   304,   307,   310,   312,   315,   318,
     320,   322,   324,   326,   328,   330,   332,   334,   336,   338,
     340,   342,   345,   348,   351,   353,   356,   359,   362,   365,
     368,   371,   374,   377,   380,   383,   386,   389,   392,   395,
     398,   401,   404,   407,   410
};
static const short yyrhs[] =
{
      -1,    90,     0,    92,     0,    90,    92,     0,    40,     0,
       0,    46,    47,    91,    58,     0,    46,    50,    91,    58,
       0,    46,    48,    91,    59,     0,    46,    52,    91,    58,
       0,    46,    53,     0,    46,    60,    53,     0,    46,    54,
       0,    46,    60,    54,     0,    46,    45,    91,    58,     0,
      46,    49,     0,    46,    60,    49,     0,    46,    51,     0,
      46,    60,    51,     0,    46,    55,     0,    46,    60,    55,
       0,    93,    94,     0,    93,    94,    98,     0,    93,    94,
      98,    97,     0,     4,    58,     0,     5,    58,     0,     3,
       0,     0,    94,    97,     0,    58,     0,    95,    58,     0,
      58,     0,    96,    58,     0,     7,    95,     0,     6,    58,
       0,     8,    96,     0,     9,    56,     0,     9,    12,     0,
      85,    58,     0,    86,    58,     0,    87,    58,     0,     9,
      13,     0,    73,     0,    60,    73,     0,    77,     0,    60,
      77,     0,    71,    58,     0,    72,    59,     0,    74,    59,
       0,    10,    57,     0,    11,    59,     0,    14,    59,    58,
       0,    14,    58,     0,    15,    58,     0,    31,    58,     0,
      32,    58,     0,    33,    58,     0,    34,    58,     0,    35,
      58,     0,    70,     0,    60,    70,     0,    60,    14,     0,
      88,     0,    60,    88,     0,   103,     0,    99,     0,   100,
       0,    99,   100,     0,   101,   102,     0,    16,    58,     0,
      16,   105,    37,     0,    16,    58,    38,     0,     0,   102,
     111,     0,   111,     0,   103,   111,     0,    41,     0,   105,
       0,   105,    41,     0,   106,     0,   105,   106,     0,    58,
       0,    58,    40,    58,     0,    58,     0,   107,    58,     0,
      58,     0,   108,    58,     0,    58,     0,   109,    58,     0,
      59,     0,   110,    59,     0,    39,   104,    37,     0,    39,
     104,     0,    36,   104,    37,     0,    36,   104,     0,    36,
      58,    38,     0,    17,    58,     0,    18,   107,     0,    19,
     108,     0,    20,   109,     0,    24,    58,     0,    25,    58,
       0,    26,   110,     0,    21,    58,     0,    22,    58,     0,
      23,     0,    27,    58,     0,    28,    58,     0,    61,     0,
      62,     0,    63,     0,    64,     0,    65,     0,    66,     0,
      67,     0,    68,     0,    69,     0,    75,     0,    76,     0,
      78,     0,    79,    58,     0,    80,    58,     0,    81,    58,
       0,    82,     0,    83,    58,     0,    84,    58,     0,    60,
      61,     0,    60,    62,     0,    60,    63,     0,    60,    64,
       0,    60,    65,     0,    60,    66,     0,    60,    67,     0,
      60,    68,     0,    60,    69,     0,    60,    75,     0,    60,
      76,     0,    60,    78,     0,    29,    59,     0,    30,    59,
       0,    43,    59,     0,    42,    59,     0,    44,    59,     0,
      45,    58,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,    85,    86,    89,    90,    93,    93,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   118,   119,   122,   126,   127,   128,   131,   132,
     135,   136,   139,   140,   143,   144,   145,   146,   147,   162,
     163,   164,   165,   173,   174,   175,   176,   177,   182,   192,
     194,   196,   198,   204,   211,   212,   227,   234,   241,   242,
     243,   244,   245,   246,   247,   250,   251,   254,   255,   258,
     261,   262,   263,   266,   267,   270,   271,   274,   275,   276,
     279,   280,   283,   285,   289,   290,   293,   294,   297,   298,
     301,   307,   315,   316,   317,   318,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     346,   353,   354,   355,   356,   357,   358,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   372,   374,
     375,   376,   377,   378,   380
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "DEFAULTS", "POLL", "SKIP", "VIA", "AKA", 
  "LOCALDOMAINS", "PROTOCOL", "AUTHENTICATE", "TIMEOUT", "KPOP", "SDPS", 
  "ENVELOPE", "QVIRTUAL", "USERNAME", "PASSWORD", "FOLDER", "SMTPHOST", 
  "FETCHDOMAINS", "MDA", "BSMTP", "LMTP", "SMTPADDRESS", "SMTPNAME", 
  "SPAMRESPONSE", "PRECONNECT", "POSTCONNECT", "LIMIT", "WARNINGS", 
  "NETSEC", "INTERFACE", "MONITOR", "PLUGIN", "PLUGOUT", "IS", "HERE", 
  "THERE", "TO", "MAP", "WILDCARD", "BATCHLIMIT", "FETCHLIMIT", "EXPUNGE", 
  "PROPERTIES", "SET", "LOGFILE", "DAEMON", "SYSLOG", "IDFILE", 
  "INVISIBLE", "POSTMASTER", "BOUNCEMAIL", "SPAMBOUNCE", "SHOWDOTS", 
  "PROTO", "AUTHTYPE", "STRING", "NUMBER", "NO", "KEEP", "FLUSH", 
  "FETCHALL", "REWRITE", "FORCECR", "STRIPCR", "PASS8BITS", "DROPSTATUS", 
  "DROPDELIVERED", "DNS", "SERVICE", "PORT", "UIDL", "INTERVAL", 
  "MIMEDECODE", "IDLE", "CHECKALIAS", "SSL", "SSLKEY", "SSLCERT", 
  "SSLPROTO", "SSLCERTCK", "SSLCERTPATH", "SSLFINGERPRINT", "PRINCIPAL", 
  "ESMTPNAME", "ESMTPPASSWORD", "TRACEPOLLS", "rcfile", "statement_list", 
  "optmap", "statement", "define_server", "serverspecs", "alias_list", 
  "domain_list", "serv_option", "userspecs", "explicits", "explicitdef", 
  "userdef", "user0opts", "user1opts", "localnames", "mapping_list", 
  "mapping", "folder_list", "smtp_list", "fetch_list", "num_list", 
  "user_option", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    89,    89,    90,    90,    91,    91,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    93,    93,    93,    94,    94,
      95,    95,    96,    96,    97,    97,    97,    97,    97,    97,
      97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
      97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
      97,    97,    97,    97,    97,    98,    98,    99,    99,   100,
     101,   101,   101,   102,   102,   103,   103,   104,   104,   104,
     105,   105,   106,   106,   107,   107,   108,   108,   109,   109,
     110,   110,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     1,     1,     2,     1,     0,     4,     4,     4,
       4,     2,     3,     2,     3,     4,     2,     3,     2,     3,
       2,     3,     2,     3,     4,     2,     2,     1,     0,     2,
       1,     2,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     1,     2,     1,     2,     2,     2,     2,
       2,     2,     3,     2,     2,     2,     2,     2,     2,     2,
       1,     2,     2,     1,     2,     1,     1,     1,     2,     2,
       2,     3,     3,     0,     2,     1,     2,     1,     1,     2,
       1,     2,     1,     3,     1,     2,     1,     2,     1,     2,
       1,     2,     3,     2,     3,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,    27,     0,     0,     0,     2,     3,    28,    25,    26,
       6,     6,     6,    16,     6,    18,     6,    11,    13,    20,
       0,     4,    22,     5,     0,     0,     0,     0,     0,    17,
      19,    12,    14,    21,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    60,     0,
       0,    43,     0,   118,   119,    45,   120,     0,     0,     0,
     124,     0,     0,     0,     0,     0,    63,    29,    23,    66,
      67,    73,    65,    75,    15,     7,     9,     8,    10,    35,
      30,    34,    32,    36,    38,    42,    37,    50,    51,    53,
       0,    54,    70,     0,    80,    97,    84,    98,    86,    99,
      88,   100,   104,   105,   101,   102,    90,   103,   107,   108,
     139,   140,    55,    56,    57,    58,    59,    77,    82,    95,
      78,    82,    93,   142,   141,   143,   144,    62,   127,   128,
     129,   130,   131,   132,   133,   134,   135,    61,    44,   136,
     137,    46,   138,    64,    47,    48,    49,   121,   122,   123,
     125,   126,    39,    40,    41,     0,    24,    68,    69,     0,
      76,    31,    33,    52,    72,     0,    71,    81,    85,    87,
      89,    91,    96,    94,    79,    92,    74,    83,     0,     0,
       0
};

static const short yydefgoto[] =
{
     208,     5,    24,     6,     7,    22,   111,   113,    97,    98,
      99,   100,   101,   188,   102,   149,   150,   124,   127,   129,
     131,   137,   103
};

static const short yypact[] =
{
      48,-32768,   -51,   -26,   221,    48,-32768,-32768,-32768,-32768,
       1,     1,     1,-32768,     1,-32768,     1,-32768,-32768,-32768,
      -7,-32768,    -5,-32768,   -22,   -13,    26,    52,    53,-32768,
  -32768,-32768,-32768,-32768,    61,    66,    76,    37,    65,    77,
      50,    79,    80,    87,    89,    91,    92,    98,    99,-32768,
     101,   102,   103,   105,   106,   121,   122,   107,   125,   130,
     131,   133,    43,    62,   134,   135,   136,   138,   109,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   154,
     155,-32768,   156,-32768,-32768,-32768,-32768,   158,   160,   161,
  -32768,   163,   164,   169,   170,   171,-32768,-32768,    81,   119,
  -32768,-32768,   181,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   172,-32768,   173,-32768,-32768,-32768,-32768,-32768,-32768,
     174,-32768,    60,    -4,-32768,-32768,-32768,   175,-32768,   176,
  -32768,   177,-32768,-32768,-32768,-32768,-32768,   178,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    67,   124,
      63,   150,   199,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,    29,-32768,-32768,   181,    64,
  -32768,-32768,-32768,-32768,-32768,   180,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   192,   213,
  -32768
};

static const short yypgoto[] =
{
  -32768,-32768,   132,   234,-32768,-32768,-32768,-32768,   142,-32768,
  -32768,   152,-32768,-32768,-32768,   189,   211,  -115,-32768,-32768,
  -32768,-32768,  -102
};


#define	YYLAST		281


static const short yytable[] =
{
     190,    34,    35,    36,    37,    38,    39,     8,   197,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,     9,   196,    63,   197,   104,    64,    65,    66,
      67,    23,    29,   157,    30,   105,    31,    32,    33,   114,
     115,     1,     2,     3,   151,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,   147,   106,   206,    34,    35,    36,
      37,    38,    39,   116,     4,    40,    41,   -82,   194,   167,
     195,   148,   168,   147,   204,   202,   171,   195,   119,   120,
     107,   108,    57,    58,    59,    60,    61,   173,   -82,   109,
     151,   151,   117,   157,   110,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   112,    42,   118,   121,   122,   169,
     170,   185,   172,    25,    26,   125,    27,   126,    28,   128,
     130,    78,    79,    80,    81,    82,   132,   133,    85,   134,
     135,   203,   136,   138,   139,   142,    93,    94,    95,    96,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     140,   141,   168,   143,   169,   170,   171,   172,   144,   145,
     195,   146,   209,   153,   154,   155,   156,   173,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,   174,   210,   175,   176,   177,    62,   178,   179,
      63,   180,   181,    64,    65,    66,    67,   182,   183,   184,
     191,   192,   193,   198,   199,   200,   205,   201,   207,    21,
     186,   189,    69,    70,    71,    72,    73,    74,    75,    76,
      77,   187,   152,   123,     0,     0,    83,    84,     0,    86,
      87,    88,    89,    90,    91,    92,    10,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,     0,     0,     0,
       0,    20
};

static const short yycheck[] =
{
     102,     6,     7,     8,     9,    10,    11,    58,   123,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    58,    37,    39,   150,    58,    42,    43,    44,
      45,    40,    49,    14,    51,    58,    53,    54,    55,    12,
      13,     3,     4,     5,    58,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    41,    59,   188,     6,     7,     8,
       9,    10,    11,    56,    46,    14,    15,    37,    38,    70,
      40,    58,    73,    41,    41,    38,    77,    40,    58,    59,
      58,    58,    31,    32,    33,    34,    35,    88,    58,    58,
      58,    58,    57,    14,    58,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    58,    16,    59,    58,    58,    75,
      76,    60,    78,    11,    12,    58,    14,    58,    16,    58,
      58,    70,    71,    72,    73,    74,    58,    58,    77,    58,
      58,    37,    59,    58,    58,    58,    85,    86,    87,    88,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      59,    59,    73,    58,    75,    76,    77,    78,    58,    58,
      40,    58,     0,    59,    59,    59,    58,    88,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    58,     0,    59,    59,    58,    36,    58,    58,
      39,    58,    58,    42,    43,    44,    45,    58,    58,    58,
      58,    58,    58,    58,    58,    58,    37,    59,    58,     5,
      98,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    99,    63,    42,    -1,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    84,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    60
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 7:
#line 96 "./rcfile_y.y"
{run.logfile = prependdir (yyvsp[0].sval, rcfiledir);}
    break;
case 8:
#line 97 "./rcfile_y.y"
{run.idfile = prependdir (yyvsp[0].sval, rcfiledir);}
    break;
case 9:
#line 98 "./rcfile_y.y"
{run.poll_interval = yyvsp[0].number;}
    break;
case 10:
#line 99 "./rcfile_y.y"
{run.postmaster = xstrdup(yyvsp[0].sval);}
    break;
case 11:
#line 100 "./rcfile_y.y"
{run.bouncemail = TRUE;}
    break;
case 12:
#line 101 "./rcfile_y.y"
{run.bouncemail = FALSE;}
    break;
case 13:
#line 102 "./rcfile_y.y"
{run.spambounce = TRUE;}
    break;
case 14:
#line 103 "./rcfile_y.y"
{run.spambounce = FALSE;}
    break;
case 15:
#line 104 "./rcfile_y.y"
{run.properties =xstrdup(yyvsp[0].sval);}
    break;
case 16:
#line 105 "./rcfile_y.y"
{run.use_syslog = TRUE;}
    break;
case 17:
#line 106 "./rcfile_y.y"
{run.use_syslog = FALSE;}
    break;
case 18:
#line 107 "./rcfile_y.y"
{run.invisible = TRUE;}
    break;
case 19:
#line 108 "./rcfile_y.y"
{run.invisible = FALSE;}
    break;
case 20:
#line 109 "./rcfile_y.y"
{run.showdots = TRUE;}
    break;
case 21:
#line 110 "./rcfile_y.y"
{run.showdots = FALSE;}
    break;
case 22:
#line 118 "./rcfile_y.y"
{record_current();}
    break;
case 24:
#line 123 "./rcfile_y.y"
{yyerror(GT_("server option after user options"));}
    break;
case 25:
#line 126 "./rcfile_y.y"
{reset_server(yyvsp[0].sval, FALSE);}
    break;
case 26:
#line 127 "./rcfile_y.y"
{reset_server(yyvsp[0].sval, TRUE);}
    break;
case 27:
#line 128 "./rcfile_y.y"
{reset_server("defaults", FALSE);}
    break;
case 30:
#line 135 "./rcfile_y.y"
{save_str(&current.server.akalist,yyvsp[0].sval,0);}
    break;
case 31:
#line 136 "./rcfile_y.y"
{save_str(&current.server.akalist,yyvsp[0].sval,0);}
    break;
case 32:
#line 139 "./rcfile_y.y"
{save_str(&current.server.localdomains,yyvsp[0].sval,0);}
    break;
case 33:
#line 140 "./rcfile_y.y"
{save_str(&current.server.localdomains,yyvsp[0].sval,0);}
    break;
case 35:
#line 144 "./rcfile_y.y"
{current.server.via = xstrdup(yyvsp[0].sval);}
    break;
case 37:
#line 146 "./rcfile_y.y"
{current.server.protocol = yyvsp[0].proto;}
    break;
case 38:
#line 147 "./rcfile_y.y"
{
					    current.server.protocol = P_POP3;

					    if (current.server.authenticate == A_PASSWORD)
#ifdef KERBEROS_V5
						current.server.authenticate = A_KERBEROS_V5;
#else
		    				current.server.authenticate = A_KERBEROS_V4;
#endif /* KERBEROS_V5 */
#if INET6_ENABLE
					    current.server.service = KPOP_PORT;
#else /* INET6_ENABLE */
					    current.server.port = KPOP_PORT;
#endif /* INET6_ENABLE */
					}
    break;
case 39:
#line 162 "./rcfile_y.y"
{current.server.principal = xstrdup(yyvsp[0].sval);}
    break;
case 40:
#line 163 "./rcfile_y.y"
{current.server.esmtp_name = xstrdup(yyvsp[0].sval);}
    break;
case 41:
#line 164 "./rcfile_y.y"
{current.server.esmtp_password = xstrdup(yyvsp[0].sval);}
    break;
case 42:
#line 165 "./rcfile_y.y"
{
#ifdef SDPS_ENABLE
					    current.server.protocol = P_POP3;
					    current.server.sdps = TRUE;
#else
					    yyerror(GT_("SDPS not enabled."));
#endif /* SDPS_ENABLE */
					}
    break;
case 43:
#line 173 "./rcfile_y.y"
{current.server.uidl = FLAG_TRUE;}
    break;
case 44:
#line 174 "./rcfile_y.y"
{current.server.uidl  = FLAG_FALSE;}
    break;
case 45:
#line 175 "./rcfile_y.y"
{current.server.checkalias = FLAG_TRUE;}
    break;
case 46:
#line 176 "./rcfile_y.y"
{current.server.checkalias  = FLAG_FALSE;}
    break;
case 47:
#line 177 "./rcfile_y.y"
{
#if INET6_ENABLE
					current.server.service = yyvsp[0].sval;
#endif /* INET6_ENABLE */
					}
    break;
case 48:
#line 182 "./rcfile_y.y"
{
#if INET6_ENABLE
					int port = yyvsp[0].number;
					char buf[10];
					sprintf(buf, "%d", port);
					current.server.service = xstrdup(buf);
#else
					current.server.port = yyvsp[0].number;
#endif /* INET6_ENABLE */
		}
    break;
case 49:
#line 193 "./rcfile_y.y"
{current.server.interval = yyvsp[0].number;}
    break;
case 50:
#line 195 "./rcfile_y.y"
{current.server.authenticate = yyvsp[0].proto;}
    break;
case 51:
#line 197 "./rcfile_y.y"
{current.server.timeout = yyvsp[0].number;}
    break;
case 52:
#line 199 "./rcfile_y.y"
{
					    current.server.envelope = 
						xstrdup(yyvsp[0].sval);
					    current.server.envskip = yyvsp[-1].number;
					}
    break;
case 53:
#line 205 "./rcfile_y.y"
{
					    current.server.envelope = 
						xstrdup(yyvsp[0].sval);
					    current.server.envskip = 0;
					}
    break;
case 54:
#line 211 "./rcfile_y.y"
{current.server.qvirtual=xstrdup(yyvsp[0].sval);}
    break;
case 55:
#line 212 "./rcfile_y.y"
{
#ifdef NET_SECURITY
					    void *request;
					    int requestlen;

		    			    if (net_security_strtorequest(yyvsp[0].sval, &request, &requestlen))
						yyerror(GT_("invalid security request"));
					    else {
						current.server.netsec = xstrdup(yyvsp[0].sval);
					        free(request);
					    }
#else
					    yyerror(GT_("network-security support disabled"));
#endif /* NET_SECURITY */
					}
    break;
case 56:
#line 227 "./rcfile_y.y"
{
#if (defined(linux) && !defined(INET6_ENABLE)) || defined(__FreeBSD__)
					interface_parse(yyvsp[0].sval, &current.server);
#else /* (defined(linux) && !defined(INET6_ENABLE)) || defined(__FreeBSD__) */
					fprintf(stderr, GT_("fetchmail: interface option is only supported under Linux (without IPv6) and FreeBSD\n"));
#endif /* (defined(linux) && !defined(INET6_ENABLE)) || defined(__FreeBSD__) */
					}
    break;
case 57:
#line 234 "./rcfile_y.y"
{
#if (defined(linux) && !defined(INET6_ENABLE)) || defined(__FreeBSD__)
					current.server.monitor = xstrdup(yyvsp[0].sval);
#else /* (defined(linux) && !defined(INET6_ENABLE)) || defined(__FreeBSD__) */
					fprintf(stderr, GT_("fetchmail: monitor option is only supported under Linux (without IPv6) and FreeBSD\n"));
#endif /* (defined(linux) && !defined(INET6_ENABLE) || defined(__FreeBSD__)) */
					}
    break;
case 58:
#line 241 "./rcfile_y.y"
{ current.server.plugin = xstrdup(yyvsp[0].sval); }
    break;
case 59:
#line 242 "./rcfile_y.y"
{ current.server.plugout = xstrdup(yyvsp[0].sval); }
    break;
case 60:
#line 243 "./rcfile_y.y"
{current.server.dns = FLAG_TRUE;}
    break;
case 61:
#line 244 "./rcfile_y.y"
{current.server.dns = FLAG_FALSE;}
    break;
case 62:
#line 245 "./rcfile_y.y"
{current.server.envelope = STRING_DISABLED;}
    break;
case 63:
#line 246 "./rcfile_y.y"
{current.tracepolls = FLAG_TRUE;}
    break;
case 64:
#line 247 "./rcfile_y.y"
{current.tracepolls = FLAG_FALSE;}
    break;
case 65:
#line 250 "./rcfile_y.y"
{record_current(); user_reset();}
    break;
case 67:
#line 254 "./rcfile_y.y"
{record_current(); user_reset();}
    break;
case 68:
#line 255 "./rcfile_y.y"
{record_current(); user_reset();}
    break;
case 70:
#line 261 "./rcfile_y.y"
{current.remotename = xstrdup(yyvsp[0].sval);}
    break;
case 72:
#line 263 "./rcfile_y.y"
{current.remotename = xstrdup(yyvsp[-1].sval);}
    break;
case 77:
#line 274 "./rcfile_y.y"
{current.wildcard =  TRUE;}
    break;
case 78:
#line 275 "./rcfile_y.y"
{current.wildcard =  FALSE;}
    break;
case 79:
#line 276 "./rcfile_y.y"
{current.wildcard =  TRUE;}
    break;
case 82:
#line 284 "./rcfile_y.y"
{save_str_pair(&current.localnames, yyvsp[0].sval, NULL);}
    break;
case 83:
#line 286 "./rcfile_y.y"
{save_str_pair(&current.localnames, yyvsp[-2].sval, yyvsp[0].sval);}
    break;
case 84:
#line 289 "./rcfile_y.y"
{save_str(&current.mailboxes,yyvsp[0].sval,0);}
    break;
case 85:
#line 290 "./rcfile_y.y"
{save_str(&current.mailboxes,yyvsp[0].sval,0);}
    break;
case 86:
#line 293 "./rcfile_y.y"
{save_str(&current.smtphunt, yyvsp[0].sval,TRUE);}
    break;
case 87:
#line 294 "./rcfile_y.y"
{save_str(&current.smtphunt, yyvsp[0].sval,TRUE);}
    break;
case 88:
#line 297 "./rcfile_y.y"
{save_str(&current.domainlist, yyvsp[0].sval,TRUE);}
    break;
case 89:
#line 298 "./rcfile_y.y"
{save_str(&current.domainlist, yyvsp[0].sval,TRUE);}
    break;
case 90:
#line 302 "./rcfile_y.y"
{
			    struct idlist *id;
			    id=save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = yyvsp[0].number;
			}
    break;
case 91:
#line 308 "./rcfile_y.y"
{
			    struct idlist *id;
			    id=save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = yyvsp[0].number;
			}
    break;
case 96:
#line 320 "./rcfile_y.y"
{current.remotename  = xstrdup(yyvsp[-1].sval);}
    break;
case 97:
#line 321 "./rcfile_y.y"
{current.password    = xstrdup(yyvsp[0].sval);}
    break;
case 101:
#line 325 "./rcfile_y.y"
{current.smtpaddress = xstrdup(yyvsp[0].sval);}
    break;
case 102:
#line 326 "./rcfile_y.y"
{current.smtpname = xstrdup(yyvsp[0].sval);}
    break;
case 104:
#line 328 "./rcfile_y.y"
{current.mda         = xstrdup(yyvsp[0].sval);}
    break;
case 105:
#line 329 "./rcfile_y.y"
{current.bsmtp       = prependdir (yyvsp[0].sval, rcfiledir);}
    break;
case 106:
#line 330 "./rcfile_y.y"
{current.listener    = LMTP_MODE;}
    break;
case 107:
#line 331 "./rcfile_y.y"
{current.preconnect  = xstrdup(yyvsp[0].sval);}
    break;
case 108:
#line 332 "./rcfile_y.y"
{current.postconnect = xstrdup(yyvsp[0].sval);}
    break;
case 109:
#line 334 "./rcfile_y.y"
{current.keep        = FLAG_TRUE;}
    break;
case 110:
#line 335 "./rcfile_y.y"
{current.flush       = FLAG_TRUE;}
    break;
case 111:
#line 336 "./rcfile_y.y"
{current.fetchall    = FLAG_TRUE;}
    break;
case 112:
#line 337 "./rcfile_y.y"
{current.rewrite     = FLAG_TRUE;}
    break;
case 113:
#line 338 "./rcfile_y.y"
{current.forcecr     = FLAG_TRUE;}
    break;
case 114:
#line 339 "./rcfile_y.y"
{current.stripcr     = FLAG_TRUE;}
    break;
case 115:
#line 340 "./rcfile_y.y"
{current.pass8bits   = FLAG_TRUE;}
    break;
case 116:
#line 341 "./rcfile_y.y"
{current.dropstatus  = FLAG_TRUE;}
    break;
case 117:
#line 342 "./rcfile_y.y"
{current.dropdelivered = FLAG_TRUE;}
    break;
case 118:
#line 343 "./rcfile_y.y"
{current.mimedecode  = FLAG_TRUE;}
    break;
case 119:
#line 344 "./rcfile_y.y"
{current.idle        = FLAG_TRUE;}
    break;
case 120:
#line 346 "./rcfile_y.y"
{
#ifdef SSL_ENABLE
		    current.use_ssl = FLAG_TRUE;
#else
		    yyerror(GT_("SSL is not enabled"));
#endif 
		}
    break;
case 121:
#line 353 "./rcfile_y.y"
{current.sslkey = prependdir (yyvsp[0].sval, rcfiledir);}
    break;
case 122:
#line 354 "./rcfile_y.y"
{current.sslcert = prependdir (yyvsp[0].sval, rcfiledir);}
    break;
case 123:
#line 355 "./rcfile_y.y"
{current.sslproto = xstrdup(yyvsp[0].sval);}
    break;
case 124:
#line 356 "./rcfile_y.y"
{current.sslcertck = FLAG_TRUE;}
    break;
case 125:
#line 357 "./rcfile_y.y"
{current.sslcertpath = prependdir(yyvsp[0].sval, rcfiledir);}
    break;
case 126:
#line 358 "./rcfile_y.y"
{current.sslfingerprint = xstrdup(yyvsp[0].sval);}
    break;
case 127:
#line 360 "./rcfile_y.y"
{current.keep        = FLAG_FALSE;}
    break;
case 128:
#line 361 "./rcfile_y.y"
{current.flush       = FLAG_FALSE;}
    break;
case 129:
#line 362 "./rcfile_y.y"
{current.fetchall    = FLAG_FALSE;}
    break;
case 130:
#line 363 "./rcfile_y.y"
{current.rewrite     = FLAG_FALSE;}
    break;
case 131:
#line 364 "./rcfile_y.y"
{current.forcecr     = FLAG_FALSE;}
    break;
case 132:
#line 365 "./rcfile_y.y"
{current.stripcr     = FLAG_FALSE;}
    break;
case 133:
#line 366 "./rcfile_y.y"
{current.pass8bits   = FLAG_FALSE;}
    break;
case 134:
#line 367 "./rcfile_y.y"
{current.dropstatus  = FLAG_FALSE;}
    break;
case 135:
#line 368 "./rcfile_y.y"
{current.dropdelivered = FLAG_FALSE;}
    break;
case 136:
#line 369 "./rcfile_y.y"
{current.mimedecode  = FLAG_FALSE;}
    break;
case 137:
#line 370 "./rcfile_y.y"
{current.idle        = FLAG_FALSE;}
    break;
case 138:
#line 372 "./rcfile_y.y"
{current.use_ssl     = FLAG_FALSE;}
    break;
case 139:
#line 374 "./rcfile_y.y"
{current.limit       = NUM_VALUE_IN(yyvsp[0].number);}
    break;
case 140:
#line 375 "./rcfile_y.y"
{current.warnings    = NUM_VALUE_IN(yyvsp[0].number);}
    break;
case 141:
#line 376 "./rcfile_y.y"
{current.fetchlimit  = NUM_VALUE_IN(yyvsp[0].number);}
    break;
case 142:
#line 377 "./rcfile_y.y"
{current.batchlimit  = NUM_VALUE_IN(yyvsp[0].number);}
    break;
case 143:
#line 378 "./rcfile_y.y"
{current.expunge     = NUM_VALUE_IN(yyvsp[0].number);}
    break;
case 144:
#line 380 "./rcfile_y.y"
{current.properties  = xstrdup(yyvsp[0].sval);}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 382 "./rcfile_y.y"


/* lexer interface */
extern char *rcfile;
extern int prc_lineno;
extern char *yytext;
extern FILE *yyin;

static struct query *hosttail;	/* where to add new elements */

void yyerror (const char *s)
/* report a syntax error */
{
    report_at_line(stderr, 0, rcfile, prc_lineno, GT_("%s at %s"), s, 
		   (yytext && yytext[0]) ? yytext : GT_("end of input"));
    prc_errflag++;
}

int prc_filecheck(const char *pathname, const flag securecheck)
/* check that a configuration file is secure */
{
#ifndef __EMX__
    struct stat statbuf;

    errno = 0;

    /* special case useful for debugging purposes */
    if (strcmp("/dev/null", pathname) == 0)
	return(PS_SUCCESS);

    /* pass through the special name for stdin */
    if (strcmp("-", pathname) == 0)
	return(PS_SUCCESS);

    /* the run control file must have the same uid as the REAL uid of this 
       process, it must have permissions no greater than 600, and it must not 
       be a symbolic link.  We check these conditions here. */

    if (lstat(pathname, &statbuf) < 0) {
	if (errno == ENOENT) 
	    return(PS_SUCCESS);
	else {
	    report(stderr, "lstat: %s: %s\n", pathname, strerror(errno));
	    return(PS_IOERR);
	}
    }

    if (!securecheck)	return PS_SUCCESS;

    if ((statbuf.st_mode & S_IFLNK) == S_IFLNK)
    {
	fprintf(stderr, GT_("File %s must not be a symbolic link.\n"), pathname);
	return(PS_IOERR);
    }

#ifndef __BEOS__
    if (statbuf.st_mode & ~(S_IFREG | S_IREAD | S_IWRITE | S_IEXEC | S_IXGRP))
    {
	fprintf(stderr, GT_("File %s must have no more than -rwx--x--- (0710) permissions.\n"), 
		pathname);
	return(PS_IOERR);
    }
#endif /* __BEOS__ */

#ifdef HAVE_GETEUID
    if (statbuf.st_uid != geteuid())
#else
    if (statbuf.st_uid != getuid())
#endif /* HAVE_GETEUID */
    {
	fprintf(stderr, GT_("File %s must be owned by you.\n"), pathname);
	return(PS_IOERR);
    }
#endif
    return(PS_SUCCESS);
}

int prc_parse_file (const char *pathname, const flag securecheck)
/* digest the configuration into a linked list of host records */
{
    prc_errflag = 0;
    querylist = hosttail = (struct query *)NULL;

    errno = 0;

    /* Check that the file is secure */
    if ( (prc_errflag = prc_filecheck(pathname, securecheck)) != 0 )
	return(prc_errflag);

    /*
     * Croak if the configuration directory does not exist.
     * This probably means an NFS mount failed and we can't
     * see a configuration file that ought to be there.
     * Question: is this a portable check? It's not clear
     * that all implementations of lstat() will return ENOTDIR
     * rather than plain ENOENT in this case...
     */
    if (errno == ENOTDIR)
	return(PS_IOERR);
    else if (errno == ENOENT)
	return(PS_SUCCESS);

    /* Open the configuration file and feed it to the lexer. */
    if (strcmp(pathname, "-") == 0)
	yyin = stdin;
    else if ((yyin = fopen(pathname,"r")) == (FILE *)NULL) {
	report(stderr, "open: %s: %s\n", pathname, strerror(errno));
	return(PS_IOERR);
    }

    yyparse();		/* parse entire file */

    fclose(yyin);	/* not checking this should be safe, file mode was r */

    if (prc_errflag) 
	return(PS_SYNTAX);
    else
	return(PS_SUCCESS);
}

static void reset_server(const char *name, int skip)
/* clear the entire global record and initialize it with a new name */
{
    trailer = FALSE;
    memset(&current,'\0',sizeof(current));
    current.smtp_socket = -1;
    current.server.pollname = xstrdup(name);
    current.server.skip = skip;
    current.server.principal = (char *)NULL;
}


static void user_reset(void)
/* clear the global current record (user parameters) used by the parser */
{
    struct hostdata save;

    /*
     * Purpose of this code is to initialize the new server block, but
     * preserve whatever server name was previously set.  Also
     * preserve server options unless the command-line explicitly
     * overrides them.
     */
    save = current.server;

    memset(&current, '\0', sizeof(current));
    current.smtp_socket = -1;

    current.server = save;
}

struct query *hostalloc(init)
/* append a host record to the host list */
struct query *init;	/* pointer to block containing initial values */
{
    struct query *node;

    /* allocate new node */
    node = (struct query *) xmalloc(sizeof(struct query));

    /* initialize it */
    if (init)
	memcpy(node, init, sizeof(struct query));
    else
    {
	memset(node, '\0', sizeof(struct query));
	node->smtp_socket = -1;
    }

    /* append to end of list */
    if (hosttail != (struct query *) 0)
	hosttail->next = node;	/* list contains at least one element */
    else
	querylist = node;	/* list is empty */
    hosttail = node;

    if (trailer)
	node->server.lead_server = leadentry;
    else
    {
	node->server.lead_server = NULL;
	leadentry = &node->server;
    }

    return(node);
}

static void record_current(void)
/* register current parameters and append to the host list */
{
    (void) hostalloc(&current);
    trailer = TRUE;
}

char *prependdir (const char *file, const char *dir)
/* if a filename is relative to dir, convert it to an absolute path */
{
    char *newfile;
    if (!file[0] ||			/* null path */
	file[0] == '/' ||		/* absolute path */
	strcmp(file, "-") == 0 ||	/* stdin/stdout */
	!dir[0])			/* we don't HAVE_GETCWD */
	return xstrdup (file);
    newfile = xmalloc (strlen (dir) + 1 + strlen (file) + 1);
    if (dir[strlen(dir) - 1] != '/')
	sprintf (newfile, "%s/%s", dir, file);
    else
	sprintf (newfile, "%s%s", dir, file);
    return newfile;
}

/* easier to do this than cope with variations in where the library lives */
int yywrap(void) {return 1;}

/* rcfile_y.y ends here */


